
(defpackage "XML" 
  (:use "COMMON-LISP"))

(in-package "XML")


;;;;K haddad 22/06/2014
;;;Cette fonction donne des nil .... Elle n'est pas modifiee
;;;Par contre dans le corps du code (voir plus loin) on enleve les nils


;;; j bresson 02/09/2010
;;; replaced "start with "begin"
(defun makebeam (self)
  (let* ((beamself (donne-figure self))
         (beamprev (donne-figure (prv-cont self)))
         (beamnext (donne-figure (nxt-cont self))))
    
    (cond ((and (in-group? self)
                (not (om::first-of-group? self))
                (not (om::last-of-group? self))
                (> beamself 0))
           (cond ((and (> beamprev 0) (> beamnext 0))
                  (beam "continue"))
                 ((and (> beamprev 0) (not (> beamnext 0)))
                  (beam "end"))
                 ((and (not (> beamprev 0)) (> beamnext 0))
                  (beam "begin"))))
          
          ((and (om::first-of-group? self) (> beamself 0))
           (if (and (in-group? (prv-cont self))
                    (> beamprev 0) (> beamnext 0) (prv-is-samegrp? self))
             (beam "continue") (beam "begin")))
          ((and (om::last-of-group? self) (> beamself 0))
           (if (and (in-group? (nxt-cont self))
                    (> beamprev 0) (> beamnext 0) (nxt-is-samegrp? self))
             (beam "continue") (beam "end")))
          
          (t ""))  ;;;;Comment K.H => Le probleme du nil vient de la !
    ))



(defmethod cons-xml-expr ((self om::chord) fig &optional (key '((G 2))) (approx 2))
  
  (let* ((figure (if (listp fig) (car fig) fig))
         (hd-and-pts (get-head-and-points figure))
         (truefigure (car hd-and-pts))
         ;(truefigure figure)
         (points (second hd-and-pts))
         (figchar (str (car (mycassq truefigure *note-types*))))
         (durtot (* (/ (om::extent self) 4) (/ 1 (om::qvalue self))))
         (inside (om::inside self))
         (strg nil))
    
    (if (= (length inside) 1)
        (progn
          (setf strg (append strg (list (str (append *t *t *t (chr "<note>") *r)))))	
          (setf strg (append strg (list (cons-xml-note (car inside)))))
          (setf strg (append strg (list (str (duree durtot)))))
          (setf strg (append strg (list (tied self))))
        
          (setf strg (append strg (list (str (type-dur figchar)))))

          (if (not (= 0 points))
              (loop for i from 1 to points
                    do 
                    (setf strg (append strg (list (str (append *t *t *t (chr "<dot/>") *r))))))
            "")

          (let ((toto (mycassq (third (mc->xmlnotes (om::midic (car inside)))) *note-accidentals*)))
            (if (not (null toto))
                (setf strg (append strg (list (str (str (accidental (car (mycassq (third (mc->xmlnotes (om::midic (car inside)))) *note-accidentals*))))))))))
          (setf strg (append strg (list (timemod self))))
          (setf strg (append strg (remove nil (list (makebeam self)))))
          (setf strg (append strg (list (groupnotation self))))
          (setf strg (append strg (list (str (append *t *t *t (chr "</note>") *r)))))
          )
      
      (progn
        (let ((frst (car inside))) ;;;premiere note de l'accord
          (setf strg (append strg (list (str (append *t *t *t (chr "<note>") *r)))))
          (setf strg (append strg (list (cons-xml-note frst))))
          (setf strg (append strg (list (str (duree durtot)))))
          (setf strg (append strg (list (tied self))))
          
          (setf strg (append strg (list (str (type-dur figchar)))))

          (if (not (= 0 points))
              (loop for i from 1 to points
                    do 
                    (setf strg (append strg (list (str (append *t *t *t (chr "<dot/>") *r))))))
            "")
          (let ((toto (mycassq (third (mc->xmlnotes (om::midic frst))) *note-accidentals*)))
            (if (not (null toto))
                (setf strg (append strg (list (str (str (accidental (car (mycassq (third (mc->xmlnotes (om::midic frst))) *note-accidentals*))))))))))
          (setf strg (append strg (list (timemod self))))
          (setf strg (append strg (remove nil (list (makebeam self)))))
          (setf strg (append strg (list (groupnotation self))))
          (setf strg (append strg (list (str (append *t *t *t (chr "</note>") *r))))))
        (loop for note in (cdr inside) ;;;;les autres notes de l'accord
              do (progn 
                   (setf strg (append strg (list (str (append *t *t *t (chr "<note>") *r)))))
                   (setf strg (append strg (list (str (append *t *t *t (chr "  <chord/>") *r)))))
                   (setf strg (append strg (list (cons-xml-note note))))
                   (setf strg (append strg (list (str (duree durtot)))))
                   (setf strg (append strg (list (tied self))))
                   
                   (setf strg (append strg (list (str (type-dur figchar)))))

                   (if (not (= 0 points))
                       (loop for i from 1 to points
                             do 
                             (setf strg (append strg (list (str (append *t *t *t (chr "<dot/>") *r))))))
                     "")

                   (let ((toto (mycassq (third (mc->xmlnotes (om::midic note))) *note-accidentals*)))
                     (if (not (null toto))
                         (setf strg (append strg (list (str (str (accidental (car (mycassq (third (mc->xmlnotes (om::midic note))) *note-accidentals*))))))))))
                   (setf strg (append strg (list (timemod self))))
                   (setf strg (append strg (remove nil (list (makebeam self)))));;??
                   (setf strg (append strg (list (groupnotation self))));;??
                   (setf strg (append strg (list (str (append *t *t *t (chr "</note>") *r))))))
              ))
      )
    strg))




(defmethod cons-xml-expr ((self om::rest) fig &optional (key '((G 2))) (approx 2))
  (let* ((figure (if (listp fig) (car fig) fig))
         (hd-and-pts (get-head-and-points figure))
         (truefigure (car hd-and-pts))
         ;(truefigure figure)
         (points (second hd-and-pts))
         (figchar (str (car (mycassq truefigure *note-types*))))
         (durtot (* (/ (om::extent self) 4) (/ 1 (om::qvalue self))))
         ;(durtot (abs (/ 1 (om::qvalue self))))
         (strg nil)) 
    (setf strg (append strg (list (str (append *t *t *t (chr "<note>") *r)))))
    (setf strg (append strg (list (str (append *t *t *t (chr "  <rest/>") *r)))))
    (setf strg (append strg (list (str (duree durtot)))))
    (setf strg (append strg (list (str (type-dur figchar)))))
    (if (not (= 0 points))
          (loop for i from 1 to points
              do 
              (setf strg (append strg (list (str (append *t *t *t (chr "<dot/>") *r))))))
          "")
    (setf strg (append strg (list (timemod self))))
    (setf strg (append strg (remove nil (list (makebeam self)))))
    (setf strg (append strg (list (groupnotation self))))
    (setf strg (append strg (list (str (append *t *t *t (chr "</note>") *r)))))
    strg
    ))


;;;;;;;;;;;;;;;Fixing the breve
;;;K Haddad
;;;22/06/2014


